﻿Imports System.IO
Imports System.IO.Ports

Public Class Form1
    Dim WithEvents serialPort As New IO.Ports.SerialPort
    Dim L As Integer
    Dim comportnum As Byte
    Dim red As Byte
    Dim speed As Byte
    Dim e1 As Byte
    Dim e2 As Byte
    Dim c As Integer
    Dim c1 As Integer
    Dim c2 As Integer
    Dim r As Integer
    Dim r1 As Integer
    Dim d As Integer
    Dim TextString As String
    Dim Letter As String

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Вычитываем путь к приложению
        'Dim sPuthDirgc As String = System.Reflection.Assembly.GetExecutingAssembly().FullName
        cmbSpeed.SelectedIndex = 0
        Try
            With serialPort
                .PortName = "COM1"
                .BaudRate = 9600
                .Parity = IO.Ports.Parity.None
                .DataBits = 8
                .StopBits = IO.Ports.StopBits.One
                .Encoding = System.Text.Encoding.Default
            End With
            serialPort.Open()

        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    ''' <summary>
    ''' 
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        serialPort.Close()
    End Sub

    ''' <summary>
    ''' Open
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'ofdText.InitialDirectory = Application.StartupPath & "\Data"
        ofdText.Filter = "Текстовые файлы(*.txt)|*.txt"
        If ofdText.ShowDialog = DialogResult.OK Then
            Dim fname As String = ofdText.FileName
            Dim sr As New StreamReader(fname, System.Text.Encoding.GetEncoding("Windows-1251"), False)
            tbText.Text = sr.ReadToEnd()
            sr.Close()
            tbText.Refresh()
        End If
    End Sub

    ''' <summary>
    ''' Save
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'sfdText.InitialDirectory = Application.StartupPath & "\Data"
        sfdText.Filter = "Текстовые файлы(*.txt)|*.txt"
        If sfdText.ShowDialog = DialogResult.OK Then
            Dim fname As String = sfdText.FileName
            Dim sw As New StreamWriter(fname, False, System.Text.Encoding.GetEncoding("Windows-1251"))
            sw.WriteLine(tbText.Text)
            sw.Flush()
            sw.Close()
        End If
    End Sub

    ''' <summary>
    ''' Run string
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadRunString.Click
        Try
            btnLoadRunString.Enabled = False
            Button1.Enabled = False
            Button2.Enabled = False

            cmbSpeed.Enabled = False

            TextString = tbText.Text
            r = Len(TextString)

            If r = 0 Then
                TextString = "      ЭТО ДЕМО РЕЖИМ. ЗАГРУЗИТЕ СВОЙ ТЕКСТ!      "
                tbText.Text = TextString
                tbText.Refresh()
                r = Len(TextString)
                System.Threading.Thread.Sleep(1000)
            End If
            'Все буквы - в верхний регистр
            If cbUpper.Checked = True Then
                TextString = TextString.ToUpper
            End If

            serialPort.Write("S")                  ' Start Mark
            If r <= 255 Then
                e1 = r
                e2 = 0
            End If
            If r > 255 Then
                e1 = 255
                e2 = r - 255
            End If
            r1 = r + 3

            For c = 1 To 512
                c2 = c / 5
                c2 = Int(c2)
                If c2 > 100 Then c2 = 100
                Me.Text = "Загрузка..." & c2 & "%"
                If c = 1 Then red = e1
                If c = 2 Then red = e2
                If c = 3 Then red = speed
                If c > 3 And c <= r1 Then
                    c1 = c - 3
                    Letter = Mid(TextString, c1, 1)
                    red = Asc(Letter)
                End If
                If c > r1 Then red = 0

                ' High Nibble
                d = red And &HF0
                d = d / 16
                d = d Or &H30
                If d > &H39 Then
                    d = d + 7
                End If
                serialPort.Write(Chr(d))

                ' Low Nibble
                d = red And &HF
                d = d Or &H30
                If d > &H39 Then
                    d = d + 7
                End If
                serialPort.Write(Chr(d))

                System.Threading.Thread.Sleep(50) 'задержка для гарантированной записи передаваемых данных в микроконтроллер
                Application.DoEvents()
            Next c

            Me.Text = "Данные загружены!"
            System.Threading.Thread.Sleep(1000)
            Me.Text = "БEГУЩAЯ CTPOКA"

            btnLoadRunString.Enabled = True
            Button1.Enabled = True
            Button2.Enabled = True
            cmbSpeed.Enabled = True
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try

    End Sub

    Private Sub cmbSpeed_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbSpeed.SelectedIndexChanged
        speed = cmbSpeed.SelectedItem
    End Sub

End Class
